-- Export Flash actionscript
-- By Squize/www.1coin1play.com
-- ( Based on code by Andre Michelle - am@andre-michelle.com )
-- v0.1 23:45 08/11/2003
--
-- Exports the map in jailbitch (outsideOfSociety) format, ie ["frameName",attribute]
-- A tiles attribute data is set in the first user field ( Please the Mappy docs for more info )
--
-- It only currently exports 1 additional layer. The data in the second layer has the prefix "b" for the frame name.
-- If using an additional layer you have to enter the start tile for that layer, so you can keep your map and object
-- data seperated.
-- Because mappy can only support 1 tileset, you will have to place your object tiles on the same sheet as your map
-- tiles ( It's recommended to place them after the last map tile ).
--
-- This exporter takes it into account if you already having a blank tile at position 0 in your tileset ( Mappy 
-- automatically inserts a blank tile at postion 0 ) so you don't have to ammend your tilesheet.



function main ()
	local width = mappy.getValue(mappy.MAPWIDTH)
	local height = mappy.getValue(mappy.MAPHEIGHT)

	local isok,asname = mappy.fileRequester (".", "Flash actionscript (*.txt)", "*.txt", mappy.MMB_SAVE)
	if isok == mappy.MMB_OK then
		if (not (string.sub (string.lower (asname), -4) == ".txt")) then
			asname = asname .. ".txt"
		end

		outas = io.open (asname, "w");
		outas:write ("_map = [\n");
		local y = 0;
		local ln = 0;

		while y < height do
			outas:write ("[");
			local x = 0;

			while x < width do
				local mapval = 0;
				local attribute = 0;
				mapval = mappy.getBlock (x, y, ln );
				attribute = mappy.getBlockValue (mapval, mappy.BLKUSER1)
				mapval = mapval-1;
				if(mapval <0) then
					mapval=0;
				end

				outas:write ("['a")
				outas:write (tostring(mapval))
				outas:write ("',")
				outas:write (tostring(attribute));
				outas:write ("]")

				if x < (width-1) then
					outas:write (",")
				else
					if y < (height-1) then
						outas:write ("],\n")
					else
						outas:write ("]\n")
					end
				end
			x = x + 1
			end
		y = y + 1
		end
		outas:write ("];\n\n")

		local isok,layerNum = mappy.doDialogue ("Export Flash actionscript", "How many additional Layers?", "1", mappy.MMB_DIALOGUE1)
		if isok == mappy.MMB_OK then

			layerNum = tonumber (layerNum)

			if(layerNum>0) then
				local isok,objectNumber = mappy.doDialogue ("Export Flash actionscript", "Tile number of the first object", "0", mappy.MMB_DIALOGUE1)
				if isok == mappy.MMB_OK then
					objectNumber = tonumber (objectNumber)

					outas:write ("_mapobjects = [\n");
					local y = 0
					local ln = 1;

					while y < height do
						outas:write ("[")
						local x = 0

						while x < width do
							local mapval = 0;
							local attribute = 0;
							mapval = mappy.getBlock (x, y, ln );
							attribute = mappy.getBlockValue (mapval, mappy.BLKUSER1)
							mapval = mapval-1;

							if (mapval <0) then
								mapval=0;
							else
								mapval = mapval-(objectNumber-2);
							end

							outas:write ("['b")
							outas:write (tostring(mapval))
							outas:write ("',")
							outas:write (tostring(attribute));
							outas:write ("]")

							if x < (width-1) then
								outas:write (",")
							else
								if y < (height-1) then
									outas:write ("],\n")
								else
									outas:write ("]\n")
								end
							end
						x = x + 1
						end
					y = y + 1
					end
					outas:write ("];\n\n");
					outas:close ();
				end
			else
				outas:close ();
			end
		end
	end
end

pcall( main )
